%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\chapter{Communication Interface}
\label{sec:communicationInterface}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
This chapter describes the communication interface that is used for the communication between frontend and backend. The next section describes the data structure definition, followed by the Swagger Editor API documentation.

\section{Data structure Definition}
\label{sec:dataStructureDefinition}
We, Grossauer \cite{Grossauer2018} and Kroiß [this paper], decided to use a JSON format for exchanging the generated AST between frontend and backend. The model of the data structure consists of an $AstNode$ with the following fields. The full JSON model documentation extracted from the Swagger Editor can be found in \ref{lst:jsonAstNode} (page \pageref{lst:jsonAstNode}).

The following paragraphs describe the fields.

\paragraph{type} This field specifies the type of the node. It can only contain the values specified by the enum.
\paragraph{name} The name field specifies the name for the current node if there is further information necessary in addition to the type (\ac{EG}, function name).
\paragraph{value} The numeric value of the current node is specified if available.
\paragraph{operator} This field stores the operator of binary expressions, if the type of the current nodes is a binary expression node.
\paragraph{startLine} The start line of the node in the corresponding source code file. The code view uses this number to highlight differences between source code files.
\paragraph{endLine} The proper end line to the start line of the current node.
\paragraph{startChar} The number of the char where the node begins corresponding to the startLine.
\paragraph{endChar} The proper end char to the start char.
\paragraph{children} This fields consists of an (possibly empty) array of further AstNodes. Each entry in the array specifies one child of the current node. Nodes that appear first in the source code file have a lower array index.

\section{Swagger Edtior - API Documentation}
The API consists of one post interface only. Callers of the interface can reach this endpoint at \textit{server-address/ast}.\\
The interface expects to parameters where both are required. The first parameter is the programming language of the source code file sent. The second parameter is the source code file the tool uses to convert it to the corresponding AstNode, specified in \ref{sec:dataStructureDefinition}.

The interface responds with an \textit{application/json} content. In case that everything is ok with the request and the processing of the input, the server responds with status code 200, and the created AstNode that contains the transformed source code file as an \ac{AST}.\\
If something is wrong with the request, \ac{EG}, a parameter is missing, the server responds with status code 400 and an error message. In the case that an error occurs while parsing the input, the server responds with status code 500.